Bug 26672 - Create metapackage to install Koha and all its dependencies
Summary: Create metapackage to install Koha and all its dependencies
Status: Pushed to master
Alias: None
Product: Koha
Classification: Unclassified
Component: Packaging (show other bugs)
Version: master
Hardware: All All
: P5 - low normal (vote)
Assignee: Mason James
QA Contact: Testopia
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2020-10-13 23:16 UTC by David Cook
Modified: 2020-12-14 22:38 UTC (History)
4 users (show)

See Also:
Change sponsored?: ---
Patch complexity: ---
Text to go in the release notes:
Version(s) released in:
20.11.00


Attachments
Bug 26672: Add koha-core and koha-full metapackages (1.35 KB, patch)
2020-10-15 01:21 UTC, David Cook
Details | Diff | Splinter Review
Bug 26672: Make koha-core not rely on koha-common and have koha-full rely on koha-core (1.47 KB, patch)
2020-10-15 01:59 UTC, David Cook
Details | Diff | Splinter Review
Bug 26672: Make koha-core not rely on koha-common and have koha-full rely on koha-core (1.55 KB, patch)
2020-11-18 10:18 UTC, Mason James
Details | Diff | Splinter Review
Bug 26672: Add koha-core and koha-full metapackages (1.43 KB, patch)
2020-11-18 10:19 UTC, Mason James
Details | Diff | Splinter Review
Bug 26672: Add koha-core and koha-full def to debian/control files (7.19 KB, patch)
2020-11-25 12:10 UTC, Mason James
Details | Diff | Splinter Review
Bug 26672: Add additional koha-core and koha-full files to ./debian (37.02 KB, patch)
2020-11-25 12:10 UTC, Mason James
Details | Diff | Splinter Review
Bug 26672: Remove unrequired default-mysql-* references (2.24 KB, patch)
2020-11-25 13:17 UTC, Mason James
Details | Diff | Splinter Review
Bug 26672: Add additional koha-core and koha-full files to ./debian (37.02 KB, patch)
2020-11-25 14:14 UTC, Mason James
Details | Diff | Splinter Review
Bug 26672: Add koha-core and koha-full definitions to debian/control files (5.77 KB, patch)
2020-11-25 14:15 UTC, Mason James
Details | Diff | Splinter Review
Bug 26672: Add additional koha-core and koha-full files to ./debian (37.11 KB, patch)
2020-11-25 15:15 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review
Bug 26672: Add koha-core and koha-full definitions to debian/control files (5.79 KB, patch)
2020-11-25 15:16 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review
Bug 26672: Add koha-core and koha-full definitions to debian/control files (4.52 KB, patch)
2020-11-25 15:26 UTC, Mason James
Details | Diff | Splinter Review
Bug 26672: Remove unrequired default-mysql-* references (2.25 KB, patch)
2020-11-25 15:31 UTC, Mason James
Details | Diff | Splinter Review
Bug 26672: Add deps to koha-core, via debian/rules file (665 bytes, patch)
2020-11-26 09:20 UTC, Mason James
Details | Diff | Splinter Review
Bug 26672: Add 'experimental' info to koha-core and koha-full descriptions (1.91 KB, patch)
2020-11-27 12:17 UTC, Mason James
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description David Cook 2020-10-13 23:16:36 UTC
To make it easier to install Koha for less technical users, there should be a metapackage to install Koha and dependencies like MariaDB, Elasticsearch, RabbitMQ, etc.

There is discussion on the listserv about choosing names. When that discussion concludes, we can do the work here to create a metapackage that installs the bare minimum Koha and a metapackage that installs a fully functioning Koha with a minimum number of steps.
Comment 1 David Cook 2020-10-15 01:10:33 UTC
There was limited feedback on the listserv, but it seems like people are OK with creating a "koha-core" metapackage (requiring koha-common) and a "koha-full" metapackage (requiring koha-common, mariadb-server, elasticsearch, RabbitMQ, etc).
Comment 2 David Cook 2020-10-15 01:21:41 UTC
Created attachment 111673 [details] [review]
Bug 26672: Add koha-core and koha-full metapackages
Comment 3 David Cook 2020-10-15 01:23:36 UTC
So far I've only included MySQL/MariaDB server and RabbitMQ, since there isn't an out-of-the-box installation option for Elasticsearch (https://wiki.koha-community.org/wiki/Koha_on_Debian#Elasticsearch). 

Perhaps we should also include a patch here to remove rabbitmq-server from koha-common as well.
Comment 4 David Cook 2020-10-15 01:38:02 UTC
Technically, we should move "memcached" from koha-common to koha-full, but I imagine that would take a lot of people by surprise... 

"koha" should also depend on "koha-full" instead of "koha-common"...

While "idzebra-2.0" includes the Zebra server (zebrasrv), it also includes the Zebra zebraidx tool, which we need on the same server as Koha. Depending on the future of Zebra in Koha, we could have a koha-zebra package. 

I suppose the depth that we take this really depends on how comfortable people are with change...
Comment 5 David Cook 2020-10-15 01:44:50 UTC
Actually, maybe koha-core shouldn't be a metapackage for koha-common after all...

We can do better than that...

This is an opportunity to really decide on what is "core"...
Comment 6 David Cook 2020-10-15 01:59:29 UTC
Created attachment 111674 [details] [review]
Bug 26672: Make koha-core not rely on koha-common and have koha-full rely on koha-core
Comment 7 Mason James 2020-11-18 10:18:20 UTC
Created attachment 113771 [details] [review]
Bug 26672: Make koha-core not rely on koha-common and have koha-full rely on koha-core

Signed-off-by: Mason James <mtj@kohaaloha.com>
Comment 8 Mason James 2020-11-18 10:19:32 UTC
Created attachment 113772 [details] [review]
Bug 26672: Add koha-core and koha-full metapackages

Signed-off-by: Mason James <mtj@kohaaloha.com>
Comment 9 David Cook 2020-11-24 22:43:05 UTC
After chatting with Mason, I think that these patches aren't going to be used and he has other patches in mind?
Comment 10 Mason James 2020-11-25 12:10:26 UTC
Created attachment 113974 [details] [review]
Bug 26672: Add koha-core and koha-full def to debian/control files
Comment 11 Mason James 2020-11-25 12:10:38 UTC
Created attachment 113975 [details] [review]
Bug 26672: Add additional koha-core and koha-full files to ./debian
Comment 12 Mason James 2020-11-25 13:17:23 UTC
Created attachment 113982 [details] [review]
Bug 26672: Remove unrequired default-mysql-* references
Comment 13 Mason James 2020-11-25 14:14:00 UTC
Created attachment 113985 [details] [review]
Bug 26672: Add additional koha-core and koha-full files to ./debian
Comment 14 Mason James 2020-11-25 14:15:15 UTC
Created attachment 113986 [details] [review]
Bug 26672: Add koha-core and koha-full definitions to debian/control files
Comment 15 Tomás Cohen Arazi 2020-11-25 15:15:46 UTC
Created attachment 113992 [details] [review]
Bug 26672: Add additional koha-core and koha-full files to ./debian

Signed-off-by: Tomas Cohen Arazi <tomascohen@theke.io>
Comment 16 Tomás Cohen Arazi 2020-11-25 15:16:00 UTC
Created attachment 113993 [details] [review]
Bug 26672: Add koha-core and koha-full definitions to debian/control files

Signed-off-by: Tomas Cohen Arazi <tomascohen@theke.io>
Comment 17 Tomás Cohen Arazi 2020-11-25 15:19:44 UTC
I like where this is going. And I will move koha-docker into using this as soon as we have this packages on the staging repo!
Comment 18 Jonathan Druart 2020-11-25 15:19:56 UTC
Pushed to master for 20.11, thanks to everybody involved!
Comment 19 Mason James 2020-11-25 15:26:18 UTC
Created attachment 113994 [details] [review]
Bug 26672: Add koha-core and koha-full definitions to debian/control files

Signed-off-by: Mason James <mtj@kohaaloha.com>
Comment 20 Mason James 2020-11-25 15:31:10 UTC
Created attachment 113995 [details] [review]
Bug 26672: Remove unrequired default-mysql-* references
Comment 21 Jonathan Druart 2020-11-25 15:37:29 UTC
(In reply to Mason James from comment #20)
> Created attachment 113995 [details] [review] [review]
> Bug 26672: Remove unrequired default-mysql-* references

Pushed to master!
Comment 22 David Cook 2020-11-25 23:32:53 UTC
(In reply to Tomás Cohen Arazi from comment #17)
> I like where this is going. And I will move koha-docker into using this as
> soon as we have this packages on the staging repo!

Yay!
Comment 23 David Cook 2020-11-25 23:39:11 UTC
Comment on attachment 113993 [details] [review]
Bug 26672: Add koha-core and koha-full definitions to debian/control files

Review of attachment 113993 [details] [review]:
-----------------------------------------------------------------

::: debian/control.in
@@ +113,5 @@
> + cron-daemon,
> + daemon,
> + debconf,
> + mysql-client | default-mysql-client | virtual-mysql-client,
> + perl-doc,

perl-doc is just Perl documentation. Perhaps it would be better suited to koha-full as well?

@@ +120,5 @@
> + sudo,
> + fonts-dejavu | ttf-dejavu,
> + unzip,
> + xmlstarlet,
> + yaz

Technically, yaz should be in koha-full rather than koha-core I think, since it's mostly utilities for working with Zebra.
Comment 24 David Cook 2020-11-25 23:54:52 UTC
Something we should keep in mind is that many of the "debian" scripts (e.g. koha-create) may not work as expected in koha-core, since they expect dependencies like Apache and Zebra to be installed. 

But I guess that means the next step is probably to improve those scripts. 

After all, we're still in the process of weaning off Apache and Zebra, so I suppose it's no surprise that any koha-core installation will probably have Apache and Zebra installed alongside it manually for the time being. It's good to have the koha-core package without those dependencies though.
Comment 25 Mason James 2020-11-26 09:20:16 UTC
Created attachment 114004 [details] [review]
Bug 26672: Add deps to koha-core, via debian/rules file
Comment 26 Jonathan Druart 2020-11-26 09:27:57 UTC
(In reply to Mason James from comment #25)
> Created attachment 114004 [details] [review] [review]
> Bug 26672: Add deps to koha-core, via debian/rules file

Pushed to master.
Comment 27 Mason James 2020-11-27 12:17:39 UTC
Created attachment 114040 [details] [review]
Bug 26672: Add 'experimental' info to koha-core and koha-full descriptions
Comment 28 Jonathan Druart 2020-11-27 12:25:16 UTC
(In reply to Mason James from comment #27)
> Created attachment 114040 [details] [review] [review]
> Bug 26672: Add 'experimental' info to koha-core and koha-full descriptions

Pushed to master.
Comment 29 Andrew Fuerste-Henry 2020-12-14 15:30:43 UTC
Doesn't apply cleanly to 20.05.x, please rebase if needed